package djmil.cordacheckers.cordaclient.dao.flow.arguments;

import djmil.cordacheckers.cordaclient.dao.GameView;
import djmil.cordacheckers.cordaclient.dao.flow.RequestBody;

public interface Rsp <T> {
    public T successStatus();
    public String failureStatus();

    public default T getResponce(RequestBody requestBody) throws RspFailureException {
        if (failureStatus() == null) {
            final var responce = successStatus();
            final String gameUuid = (responce instanceof GameView) 
               ? "GameUUID " +((GameView)responce).uuid().toString()
               : "";
            
            System.out.println(requestBody.clientRequestId() +" [OK] " +gameUuid);
            return responce;
        }

        System.err.println(requestBody.clientRequestId() +" has failed: " +failureStatus());
        throw new RspFailureException(failureStatus());
    }

}