package djmil.cordacheckers;

import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PutMapping;

import jakarta.servlet.http.HttpServletRequest;

@Controller
public class ReactAppController {
    // This controller simply redirects all UI related routes
    // to index.html, allowing react and react-router to work its magic

    @GetMapping(value = { "", "/", "/games", "/games/*", "/about","/leaderboard" })
    @PutMapping("/error")
    public String getIndex(HttpServletRequest inRequest) {
        return "/index.html";
    }

}
