import React from 'react';

export default function BadMove({ dispatchGuide, uuid, message }) {
  if (!dispatchGuide || !uuid || !message)
    return;

  return (
    <div className='BadMove'
      onClick={() => dispatchGuide({ type: 'UUIDerror', uuid, error: {} })}
    >
      {message}
    </div>
  )
}